﻿#pragma once

//错误代码
#define ERR_OK (0)			//成功
#define ERR_CONNECT (-1)	//连接失败
#define ERR_TYPE (-3)		//元件类型
#define ERR_NUM (-4)		//数量越界

#define YK_MEM extern "C" int __stdcall

YK_MEM GetVer();
YK_MEM Connect();
YK_MEM ConnectEx(UINT32 gccat);
YK_MEM Close();

#pragma region 字元件
//T计时器元件读写
YK_MEM WriteWordT(unsigned int index, unsigned int num, unsigned short *data);
YK_MEM ReadWordT(unsigned int index, unsigned int num, unsigned short *data);

//C计数器元件读写
YK_MEM WriteWordC16(unsigned int index, unsigned int num, unsigned short *data);
YK_MEM ReadWordC16(unsigned int index, unsigned int num, unsigned short *data);

//C高速计数器元件读写
YK_MEM WriteWordC32(unsigned int index, unsigned int num, unsigned short *data);
YK_MEM ReadWordC32(unsigned int index, unsigned int num, unsigned short *data);

//D寄存器元件读写
YK_MEM WriteWordD(unsigned int index, unsigned int num, unsigned short *data);
YK_MEM ReadWordD(unsigned int index, unsigned int num, unsigned short *data);

//SD寄存器元件读写
YK_MEM WriteWordSD(unsigned int index, unsigned int num, unsigned short *data);
YK_MEM ReadWordSD(unsigned int index, unsigned int num, unsigned short *data);

//R寄存器元件读写
YK_MEM WriteWordR(unsigned int index, unsigned int num, unsigned short *data);
YK_MEM ReadWordR(unsigned int index, unsigned int num, unsigned short *data);

//RD寄存器元件读写
YK_MEM WriteWordRD(unsigned int index, unsigned int num, unsigned short *data);
YK_MEM ReadWordRD(unsigned int index, unsigned int num, unsigned short *data);

//VD寄存器元件读写
YK_MEM WriteWordVD(unsigned int index, unsigned int num, unsigned short *data);
YK_MEM ReadWordVD(unsigned int index, unsigned int num, unsigned short *data);

#pragma endregion


#pragma region 位元件
//X输入继电器元件读写
YK_MEM WriteBitX(unsigned int index, unsigned int num, unsigned short *data);
YK_MEM ReadBitX(unsigned int index, unsigned int num, unsigned short *data);

//Y输出继电器元件读写
YK_MEM WriteBitY(unsigned int index, unsigned int num, unsigned short *data);
YK_MEM ReadBitY(unsigned int index, unsigned int num, unsigned short *data);

//M辅助继电器元件读写
YK_MEM WriteBitM(unsigned int index, unsigned int num, unsigned short *data);
YK_MEM ReadBitM(unsigned int index, unsigned int num, unsigned short *data);

//SM继电器元件读写
YK_MEM WriteBitSM(unsigned int index, unsigned int num, unsigned short *data);
YK_MEM ReadBitSM(unsigned int index, unsigned int num, unsigned short *data);

//S状态继电器元件读写
YK_MEM WriteBitS(unsigned int index, unsigned int num, unsigned short *data);
YK_MEM ReadBitS(unsigned int index, unsigned int num, unsigned short *data);

//B继电器元件读写
YK_MEM WriteBitB(unsigned int index, unsigned int num, unsigned short *data);
YK_MEM ReadBitB(unsigned int index, unsigned int num, unsigned short *data);

//L继电器元件读写
YK_MEM WriteBitL(unsigned int index, unsigned int num, unsigned short *data);
YK_MEM ReadBitL(unsigned int index, unsigned int num, unsigned short *data);

//F继电器元件读写
YK_MEM WriteBitF(unsigned int index, unsigned int num, unsigned short *data);
YK_MEM ReadBitF(unsigned int index, unsigned int num, unsigned short *data);

#pragma endregion

#pragma region 数据转换
YK_MEM FloatToWordT(float fv, unsigned short *word);
YK_MEM WordToFloatT(unsigned short *word, float *fv);

YK_MEM WordToIntT(unsigned short *word, int *iv);
YK_MEM IntToWordT(int iv, unsigned short *word);

YK_MEM WordToByteT(unsigned short *word, BYTE *iv);
YK_MEM ByteToWordT(BYTE *iv, unsigned short *word);


//返回0=正常 1=内存未打开 2=写超时
UINT32 WriteCadData(UINT32 index, UINT8* data, UINT32 len);
#pragma endregion
