﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;

namespace TestCS
{
    public enum MyEnum
    {
        ERR_OK = 0,         //成功
        ERR_CONNECT = -1,   //连接失败
        ERR_HANDLE = -2,    //句柄
        ERR_TYPE = -3,      //元件类型
        ERR_NUM = -4,       //数量越界
        ERR_SKT = -5,
        ERR_REV = -6,
    }
   public class YKMem
    {
        //获得版本
        /// <summary>
        /// 连接ProH
        /// </summary>
        /// <param IP地址="ip_addr"></param>
        /// <param 端口号="ip_port"></param>
        /// <returns></returns>
        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int GetVer();

        //YKMem的连接与关闭
        /// <summary>
        /// 连接ProH
        /// </summary>
        /// <returns></returns>
        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int Connect();

        //YKMem的连接与关闭
        /// <summary>
        /// 连接ProH
        /// </summary>
        /// <param "gccat">1=gccat模式  0=mcsim模式</param>
        /// <returns></returns>
        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int ConnectEx(UInt32 gccat);

        /// <summary>
        /// 关闭通道
        /// </summary>
        /// <param  Connect函数返回的句柄="handle"></param>
        /// <returns></returns>
        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int Close();

        /// <summary>
        /// /
        /// </summary>
        /// <param Connect函数返回的句柄="handle"></param>
        /// <param 读取或写入元件的起始="index"></param>
        /// <param 读取或写入元件的数量="num"></param>
        /// <param 读取或写入元件的数据="data"></param>
        /// <returns></returns>
        //T计时器元件读写
        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteWordT(uint index, uint num, ushort[] data);

        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadWordT(uint index, uint num, ushort[] data);

        //C计数器元件读写
        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteWordC16(uint index, uint num, ushort[] data);

        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadWordC16(uint index, uint num, ushort[] data);

        //C高速计数器元件读写
        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteWordC32(uint index, uint num, ushort[] data);

        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadWordC32(uint index, uint num, ushort[] data);

        //D寄存器元件读写
        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteWordD(uint index, uint num, ushort[] data);

        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadWordD(uint index, uint num, ushort[] data);

        //SD寄存器元件读写
        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteWordSD(uint index, uint num, ushort[] data);

        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadWordSD(uint index, uint num, ushort[] data);

        //R寄存器元件读写
        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteWordR(uint index, uint num, ushort[] data);

        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadWordR(uint index, uint num, ushort[] data);

        //RD寄存器元件读写
        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteWordRD(uint index, uint num, ushort[] data);

        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadWordRD(uint index, uint num, ushort[] data);

        //VD寄存器元件读写
        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteWordVD(uint index, uint num, ushort[] data);

        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadWordVD(uint index, uint num, ushort[] data);



        /// <summary>
        /// 
        /// </summary>
        /// <param Connect函数返回的句柄="handle"></param>
        /// <param 读取或写入元件的起始="index"></param>
        /// <param 读取或写入元件的数量="num"></param>
        /// <param 读取或写入元件的数据="data"></param>
        /// <returns></returns>
        //X输入继电器元件读写
        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteBitX(uint index, uint num, ushort[] data);

        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadBitX(uint index, uint num, ushort[] data);

        //Y输出继电器元件读写
        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteBitY(uint index, uint num, ushort[] data);

        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadBitY(uint index, uint num, ushort[] data);

        //M辅助继电器元件读写
        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteBitM(uint index, uint num, ushort[] data);

        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadBitM(uint index, uint num, ushort[] data);

        //SM继电器元件读写
        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteBitSM(uint index, uint num, ushort[] data);

        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadBitSM(uint index, uint num, ushort[] data);

        //S状态继电器元件读写
        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteBitS(uint index, uint num, ushort[] data);

        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadBitS(uint index, uint num, ushort[] data);


        //B继电器元件读写
        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteBitB(uint index, uint num, ushort[] data);

        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadBitB(uint index, uint num, ushort[] data);

        //L继电器元件读写
        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteBitL(uint index, uint num, ushort[] data);

        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadBitL(uint index, uint num, ushort[] data);

        //F继电器元件读写
        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteBitF(uint index, uint num, ushort[] data);

        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadBitF(uint index, uint num, ushort[] data);

        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum FloatToWordT(float fv, ushort[] data);

        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WordToFloatT(ushort[] word, ref float fv);

        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum IntToWordT(int iv, ushort[] data);

        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WordToIntT(ushort[] word, ref int iv);

        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WordToByteT(ushort[] word, byte[] iv);


        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ByteToWordT(byte[] iv, ushort[] data);


        [DllImport("YKMem.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteCadData(UInt32 index, Byte[] data, UInt32 len);

    }
}
